LibreOffice: AffineMatrix3D Struct Reference

LibreOffice LibreOffice 7.3 SDK API Reference

Loading...
Searching...
No Matches
Public Attributes | List of all members
AffineMatrix3D Struct Reference

This structure defines a 3 by 4 affine matrix. More...

## Public Attributes
double | m00
| The top, left matrix entry. More...
double | m01
| The top, left middle matrix entry. More...
double | m02
| The top, right middle matrix entry. More...
double | m03
| The top, right matrix entry. More...
double | m10
| The middle, left matrix entry. More...
double | m11
| The middle, middle left matrix entry. More...
double | m12
| The middle, middle right matrix entry. More...
double | m13
| The middle, right matrix entry. More...
double | m20
| The bottom, left matrix entry. More...
double | m21
| The bottom, middle left matrix entry. More...
double | m22
| The bottom, middle right matrix entry. More...
double | m23
| The bottom, right matrix entry. More...

## Detailed Description

This structure defines a 3 by 4 affine matrix.

The matrix defined by this structure constitutes an affine mapping of a point in 3D to another point in 3D. The last line of a complete 4 by 4 matrix is omitted, since it is implicitly assumed to be [0,0,0,1].

An affine mapping, as performed by this matrix, can be written out as follows, where `xs, ys` and `zs` are the source, and `xd, yd` and `zd` the corresponding result coordinates:

`xd = m00*xs + m01*ys + m02*zs + m03; yd = m10*xs + m11*ys + m12*zs + m13; zd = m20*xs + m21*ys + m22*zs + m23;`

Thus, in common matrix language, with M being the AffineMatrix3D and vs=[xs,ys,zs]^T, vd=[xd,yd,zd]^T two 3D vectors, the affine transformation is written as vd=M*vs. Concatenation of transformations amounts to multiplication of matrices, i.e. a translation, given by T, followed by a rotation, given by R, is expressed as vd=R*(T*vs) in the above notation. Since matrix multiplication is associative, this can be shortened to vd=(R*T)*vs=M'*vs. Therefore, a set of consecutive transformations can be accumulated into a single AffineMatrix3D, by multiplying the current transformation with the additional transformation from the left.

Due to this transformational approach, all geometry data types are points in abstract integer or real coordinate spaces, without any physical dimensions attached to them. This physical measurement units are typically only added when using these data types to render something onto a physical output device. For 3D coordinates there is also a projection from 3D to 2D device coordinates needed. Only then the total transformation matrix (including projection to 2D) and the device resolution determine the actual measurement unit in 3D.

Since
  OOo 2.0

## Member Data Documentation

## ◆ m00

double m00

The top, left matrix entry.

## ◆ m01

double m01

The top, left middle matrix entry.

## ◆ m02

double m02

The top, right middle matrix entry.

## ◆ m03

double m03

The top, right matrix entry.

## ◆ m10

double m10

The middle, left matrix entry.

## ◆ m11

double m11

The middle, middle left matrix entry.

## ◆ m12

double m12

The middle, middle right matrix entry.

## ◆ m13

double m13

The middle, right matrix entry.

## ◆ m20

double m20

The bottom, left matrix entry.

## ◆ m21

double m21

The bottom, middle left matrix entry.

## ◆ m22

double m22

The bottom, middle right matrix entry.

## ◆ m23

double m23

The bottom, right matrix entry.

The documentation for this struct was generated from the following file:

- com/sun/star/geometry/AffineMatrix3D.idl